from zeep import Client
from zeep.transports import Transport
from lxml.etree import fromstring

# PJM Connect credentials
# example username = "ConnectUser77"
# example password = "StrongP@ssword"
username = "username"
password = "password"

# Destination folder for downloaded files
# example = "C:\\Download\\Files\\"
output_folder = "file path"

# Optional Search Options 
# rootFolder: set to "" to start at topmost level. Enter a folder path to start file search from that level. Example = "/ftppjmcom/account/auction-user-info/downloads"
# recursiveSearch: set to True to iterate through each folder. Set to False to only grab files from rootFolder. If set to False, we recommend setting a rootFolder
rootFolder = ""
recursiveSearch = True

# The remaining code won't need modification for many use cases. However, please modify to suit your needs.
#
#
#

# Connect site URL
domain = "https://connectapis.pjm.com/"
site = "sites/ftp"

# Connect library that contains the files
library_name = "File Transfers"

#Create url for SOAP calls
site_url = domain + site

# Create a SOAP client
authClient = Client(site_url + "/_vti_bin/Authentication.asmx?WSDL")

# Call the Login method
result = authClient.service.Login(username, password)
authSession = authClient.transport.session

# Create a SOAP client for the Lists Web Service
listsClient = Client(site_url + "/_vti_bin/Lists.asmx?WSDL",
    transport=Transport(session=authSession))

# Build query for GetListItems SOAP call
query = fromstring("<Query></Query>")
queryOptionsRecursive = "<ViewAttributes Scope=\"RecursiveAll\"/>"
if recursiveSearch == False:
    queryOptionsRecursive = "<ViewAttributes Scope=\"All\"/>"
queryOptionsFolder = ""
if rootFolder != "":
    queryOptionsFolder = site_url + rootFolder
queryOptions = fromstring("<QueryOptions><Folder>" + queryOptionsFolder + "</Folder>" + queryOptionsRecursive + "</QueryOptions>")
#queryOptions = fromstring("<QueryOptions><ViewAttributes Scope=\"RecursiveAll\"/></QueryOptions>")

# Call the GetListItems method with appropriate parameters
result = listsClient.service.GetListItems(
    listName=library_name,
    rowLimit=0,
    query=query,
    queryOptions = queryOptions
)

# Create a SOAP client for the Copy Web Service
copyClient = Client(site_url + "/_vti_bin/Copy.asmx?WSDL",
    transport=Transport(session=authSession))

# Parse the result to retrieve items
items = result.xpath("//z:row", namespaces={'z': '#RowsetSchema'})
for item in items:
    # Access item properties
    file_Id = item.attrib['ows_ID']
    file_name = item.attrib['ows_FileLeafRef'].split("#")[1]
    file_url= domain + item.attrib['ows_FileRef'].split("#")[1]
    file_type = item.attrib['ows_FSObjType'].split("#")[1]
    # Filter files from results. O is files and 1 is folders
    if file_type == '0':
        # Retrieve file binary and write file
        response  = copyClient.service.GetItem(Url=file_url)
        with open(output_folder + file_name, 'wb') as file:
            file.write(response['Stream'])



